<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="utf-8">
  <title>Ada for Automation Project</title>
  <link rel="stylesheet" href="https://www.w3schools.com/lib/w3.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
</head>

<body>
  <header id="top">
    <div class="w3-container w3-blue">
      <img src="./img/A4A_logo.svg" width=100 alt="Logo" style="display:inline" class="w3-right">
      <h1>Ada for Automation Project</h1>
    </div>
    <nav class="w3-topnav w3-medium w3-blue">
      <a href="#basic"><i class="fa fa-home w3-small"></i></a>
      <a href="https://demo.ada4automation.org/" target="_blank">Demo Portal</a>
      <a href="https://ada-for-automation.gitlab.io/ada-for-automation/docu/index.html" target="_blank">Documentation Portal</a>
      <a href="https://ada-for-automation.gitlab.io/ada-for-automation/" target="_blank">GitLab Pages</a>
      <a href="https://gitlab.com/ada-for-automation/ada-for-automation" target="_blank">GitLab Home</a>
      <a href="https://slo-ist.fr/" target="_blank">Author's Blog</a>
      <div class="w3-dropdown-hover">
        <a href="https://ada-for-automation.gitlab.io/ada-for-automation/docu/book/A4A-Book-fr.html" target="_blank">Help</a>
        <div class="w3-dropdown-content w3-blue w3-card-4">
          <a href="https://ada-for-automation.gitlab.io/ada-for-automation/docu/book/A4A-Book-fr.html" target="_blank">French Online Help</a>
          <a href="https://ada-for-automation.gitlab.io/ada-for-automation/docu/book/A4A-Book-en.html" target="_blank">English Online Help</a>
          <a href="#" onclick="document.getElementById('about-box').style.display='block'">About</a>
          <a href="https://www.ada4automation.org/" target="_blank">Ada for Automation</a>
        </div>
      </div>
    </nav>
  </header>

  <div id="main-content">
    <div id="about-box" class="w3-modal">
      <div class="w3-modal-content w3-card-8">
        <header class="w3-container w3-light-blue">
          <span onclick="document.getElementById('about-box').style.display='none'" class="w3-closebtn">Close &times;</span>
          <h2>About Ada for Automation Project</h2>
        </header>
        <div class="w3-container">
          <h3>Application description</h3>
          <p>
            This is the Ada for Automation Project main web site.</p>
        </div>
        <footer class="w3-container w3-light-blue">
          <h3>Application version</h3>
          <span>2021/11/14</span>
        </footer>
      </div>
    </div>

    <section id="what" class="w3-section">

      <header class="w3-container w3-light-blue w3-padding-8">
        <h2>What it is and which purpose it serves</h2>
        <a href="#top"><i class="fa fa-arrow-up w3-large w3-right"></i></a>
        <a href="#basic"><i class="fa fa-arrow-down w3-large w3-right"></i></a>
      </header>

      <div class="w3-container w3-padding-16 w3-border">
        <h2>What it is</h2>
        <p>Ada for Automation (A4A in short) is a framework for designing industrial automation applications using the Ada language.</p>
        <p>It makes use of the <a href="https://libmodbus.org" target="_blank">libmodbus</a> library to allow building a ModbusTCP client or server,
           or a Modbus RTU master or slave.</p>
        <p>It can also use <a href="https://www.hilscher.com" target="_blank">Hilscher</a> communication boards allowing to communicate on field buses
           like AS-Interface, CANopen, CC-Link, DeviceNet, PROFIBUS, EtherCAT, Ethernet/IP, Modbus TCP, PROFINET, Sercos III, POWERLINK, or VARAN.</p>
        <p>With the help of <a href="https://docs.adacore.com/live/wave/gtkada/html/gtkada_rm/index.html" target="_blank">GtkAda</a>, the binding to
           the <a href="https://www.gtk.org" target="_blank">Graphic Tool Kit</a>, one can design Graphical User Interfaces.</p>
        <p>Thanks to <a href="http://www.gnoga.com" target="_blank">Gnoga</a>, built on top of
           <a href="http://www.dmitry-kazakov.de/ada/components.htm" target="_blank">Simple Components</a>, it is also possible to provide a Web User Interface.</p>
        <p>Nice addition is the binding to the <a href="http://snap7.sourceforge.net" target="_blank">Snap7</a> library which allows to communicate with
           SIEMENS S7 PLCs using S7 Communication protocol ISO on TCP (RFC1006).</p>
        <p>Of course, all the Ada ecosystem is available.</p>
        <p>Using Ada bindings, C, C++, Fortran libraries can also be used.</p>
        <p>And, since it is Ada, it can be compiled using the same code base to target all major platforms.</p>
      </div>

      <div class="w3-container w3-padding-16 w3-border">
        <h2>Please see Main Read Me</h2>
        <p><a href="https://ada-for-automation.gitlab.io/ada-for-automation/docu/ReadMe/README.html" target="_blank">Main Read Me</a></p>
        <h2>Next section highlights a demo from the Demo Portal</h2>
        <p><a href="https://demo.ada4automation.org/" target="_blank">Demo Portal</a></p>
      </div>

    </section>

    <section id="app3" class="w3-section">

      <header class="w3-container w3-light-blue w3-padding-8">
        <h2>Ada for Automation Modbus TCP Server / S7 Gateway</h2>
        <a href="#what"><i class="fa fa-arrow-up w3-large w3-right"></i></a>
        <a href="#bottom"><i class="fa fa-arrow-down w3-large w3-right"></i></a>
      </header>

      <div class="w3-container w3-padding-16 w3-border">
        <h2>Summary</h2>
        <p>This example shows a gateway application, running on an industrial PC on top of a GNU/Linux Debian
          connected to a SIEMENS S7 PLC using S7 Communication ISO on TCP (RFC1006) thanks to the
          <a href="http://snap7.sourceforge.net/" target="_blank">Snap7 library</a> Ada binding.
        </p>
        <p>If the SIEMENS S7 PLC does not have an Ethernet port, S7 Communication ISO on TCP (RFC1006) can be added by pluging a
          <a href="https://www.hilscher.com/products/product-groups/gateways/for-direct-mounting-plug/nl-50-mpi/?" target="_blank">netLINK</a>
          on a MPI or PROFIBUS port.
        </p>

        <p><iframe src="https://a4a-k0-s7.demo.ada4automation.org/#main" height="512" width="640"></iframe>
          <iframe src="https://slo-ist.fr/wp-content/uploads/2021/10/A4A-K0-S7-00.png" height="512" width="640"></iframe>
        </p>
        <p><img src="./img/A4A_K0_S7-SIEMENS-S7-Cloud.png" alt="App3 in the Cloud"></p>
      </div>

      <div class="w3-container w3-light-grey w3-padding-16 w3-border">
        <p>Here is a link to Application 3 :<br>
          <a href="https://a4a-k0-s7.demo.ada4automation.org" target="_blank">Application 3</a>
        </p>
      </div>

    </section>

  </div>

  <footer id="bottom" class="w3-container w3-light-blue w3-center">
    <a href="#top"><i class="fa fa-arrow-up w3-large w3-right"></i></a>
    <h5>Application proudly built upon
      <a href="https://www.ada4automation.org/" target="_blank">Ada for Automation</a>
    </h5>

    <p>Copyright &copy; 2023 St&eacute;phane LOS<br></p>
  </footer>

  <noscript>Your browser must support JavaScript and be HTML 5 compliant to see this site.</noscript>
</body>

</html>
